--Beispielscript kopiert Masken-Testfälle auf der Basis Studierende Datenblatt zu DB-Tests
--Achtung: uniquenames müssen angepaßt werden

-- truncate table qa_dbtest_assertion 
 -- ;
 -- truncate table qa_dbtest2project
 -- ;
 -- truncate table qa_dbtest
 -- ; 
 begin work;
 
 select E.tid,E.name,E.uniquename,F.name as feldname,S.field_value,
(case when F.name='Filter Studierende' then '${' || trim(S.field_value) || '}'
when F.name in ('Hörerstatus','Köpfe oder Fälle ?') then S.field_value
when F.name='Status' then 'kz_rueck_beur_ein in (' || trim(S.field_value) || ')'
when F.name='Bis Semester' then 'sem_rueck_beur_ein<=' || S.field_value
when F.name='Seit Semester' then 'sem_rueck_beur_ein>=' || S.field_value
when F.name='Stichtag' then 'stichtag=' || S.field_value
when F.name='bis Fachsemester' then 'fach_sem_zahl <=' || S.field_value
when F.name='Geschlecht' then 'geschlecht=' || S.field_value
when F.name='Felder' then ''
else 'Unbekanntes Feld' end)::varchar(255) as sqlwhere
into tmp_tc
 from qa_mask_execution E, qa_mask_field_sel S, felderinfo F
where E.tid=S.mask_execution_id
and F.tid=S.felderinfo_id
--and E.uniquename='160440_Köpfe_20182_amtlich_01.4_04_Bachelor_mit_LA'
and E.maskeninfo_id=160440
and 2=(select count(*)
from qa_mask_field_sel S2, felderinfo F2
where E.tid=S2.mask_execution_id
and F2.tid=S2.felderinfo_id
and (
(F2.name='Felder'and S2.field_value='sos_stg_aggr.summe')
or 
(F2.name='Stichtag' and S2.field_value='1')
)
)
order by 1,2;

select distinct E.tid into temp tmp_invalid
from tmp_tc E where sqlwhere = 'Unbekanntes Feld';
delete from tmp_tc where tid in (select V.tid from tmp_invalid V);

select A.result_value_max,E.* 
into tmp_dbtest
from qa_mask_execution_assert A, tmp_tc E
where E.tid=A.mask_execution_id
and result_value_max=result_value_min
and is_active=1
and rownr=1
and colnr=1;


insert into qa_dbtest(tid,
       uniquename,
       name,
       systeminfo_id,
       resultset_id,
       whereclause,
       description,
       active
 )
select tid,
       uniquename,
       name,
       7 as systeminfo_id,
       (select R.tid from qa_resultset R where R.uniquename='students_dp_amtlich_summen') as resultset_id,
       array_to_string(array_agg(sqlwhere),' and ') as whereclause,
       '' as description,
       1 as active
 from tmp_dbtest T
 where T.sqlwhere !=''
group by 1,2,3,4,5;

insert into qa_dbtest2project
(
       dbtest_id,
       project_id )
       select distinct T.tid,
       (select P.tid from qa_project P where P.uniquename='Studierende amtlich Summen')
FROM tmp_dbtest T
 ;
 
insert into qa_dbtest_assertion
(
       dbtest_id,
       rownr,
       def_col_caption,
       def_col_name,
       def_col_value)
       select distinct T.tid,
       1 as rownr,
       'Summe',
       'summe',
       T.result_value_max
FROM tmp_dbtest T
 ;

 select 'Erfolgreich migrierte Tests';
 
 select distinct T.name
 from tmp_dbtest T
 order by 1;
 
 delete from qa_mask_execution_assert_result
 where mask_execution_assert_id in (select A.tid
 from qa_mask_execution_assert A, tmp_dbtest T
 where A.mask_execution_id=T.tid);
 
 
  delete from qa_mask_execution_assert
 where mask_execution_id in (select T.tid from tmp_dbtest T);

 delete from qa_mask_field_sel
  where mask_execution_id in (select T.tid from tmp_dbtest T);
 
  delete from qa_mask_execution
 where tid in (select T.tid
 from tmp_dbtest T);
  
 drop table tmp_dbtest;
 drop table tmp_tc;
 
 select sp_update_sequence('qa_dbtest');
 commit;
 
-- truncate table qa_dbtest_assertion 
 -- ;
 -- truncate table qa_dbtest2project
 -- ;
 -- truncate table qa_dbtest
 -- ; 
