

create temp table tmp_mask_field_sel(
uniquename	varchar(255),
mask_execution_id INTEGER , 
felderinfo_id INTEGER , 
field_value VARCHAR(255) , 
is_active smallint  default 1  not null
) 
;

create temp table tmp_mask_execution_assert(
uniquename	varchar(255),
mask_execution_id INTEGER , 
rownr INTEGER , 
colnr INTEGER , 
result_value_min FLOAT , 
result_value_max FLOAT , 
is_active smallint  default 1  not null,
caption            varchar(255)
) 
;

update qa_mask_execution set userinfo_id=${userid}
where uniquename || '_' || systeminfo_id in (
select distinct W.testfall_schluessel || '_' || W.systeminfo_id 
from tmp_testfall_import_feldwerte W);



insert into tmp_mask_field_sel(uniquename	,
mask_execution_id  , 
felderinfo_id  , 
field_value)
select W.testfall_schluessel,
Q.tid,
F.tid,
W.feldwert
from qa_mask_execution Q, tmp_testfall_import_feldwerte W, tmp_testfall_import_felder E, felderinfo F, masken_felder_bez M
where Q.uniquename=W.testfall_schluessel
and Q.systeminfo_id=W.systeminfo_id
and E.feldnr=W.feldnr
and M.felderinfo_id=F.tid
and M.maskeninfo_id=W.maskeninfo_id
and E.feldname=F.name;

insert into tmp_mask_execution_assert( 
mask_execution_id,
--       search_string,
       result_value_min,
       result_value_max,
       is_active,
       rownr,
       colnr,
       caption)
       select Q.tid as        mask_execution_id,
--       search_string,
--E.testfall_schluessel,
       result_value_min,
       result_value_max,
       1 as is_active,
       rownr,
       colnr,
       caption
       
from qa_mask_execution Q, tmp_testfall_import_erg E
where Q.uniquename=E.testfall_schluessel
and Q.systeminfo_id=E.systeminfo_id;

--löschen:

delete from qa_mask_execution_assert_result
where mask_execution_assert_id in (select A.tid
from qa_mask_execution_assert A
where A.mask_execution_id in (select distinct 
T.mask_execution_id from tmp_mask_execution_assert T));

delete from qa_mask_execution_assert
where mask_execution_id in (select distinct 
Q.tid from qa_mask_execution Q, tmp_testfall_import_feldwerte W
where W.testfall_schluessel=Q.uniquename
and W.systeminfo_id =Q.systeminfo_id 
);


delete from qa_mask_field_sel
where mask_execution_id in (select distinct 
T.mask_execution_id from tmp_mask_field_sel T)
;

--nun einfügen:
insert into qa_mask_field_sel(
mask_execution_id  , 
felderinfo_id  , 
field_value)
select 
mask_execution_id  , 
felderinfo_id  , 
field_value
from tmp_mask_field_sel;

insert into qa_mask_execution_assert( 
mask_execution_id,
--       search_string,
       result_value_min,
       result_value_max,
       is_active,
       rownr,
       colnr,
       caption)
       select 
        mask_execution_id,
--       search_string,
       result_value_min,
       result_value_max,
       1 as is_active,
       rownr,
       colnr,
       caption
 from tmp_mask_execution_assert;
 
drop table   tmp_mask_field_sel;
drop table tmp_mask_execution_assert;

drop table tmp_testfall_import_felder;
drop table tmp_testfall_import_feldwerte;
drop table tmp_testfall_import_erg;
