--Freemarker Template
--Achtung: Macro fügt Inhalte ein
--Bitte nur Freemarker Variablen füllen
<sqlvars>
<sqlvar name="sx_jobs_exists">select sp_table_exists('sx_jobs') from xdummy;</sqlvar>
</sqlvars>

<#assign jobs = [
{"uniquename":"testfall_import", "caption":"QA Testfälle einlesen", "filepath":"qa/etl/testfall_import/testfall_import.kjb","sachgebiete_id":260,
  "kenn_profil":"","hs_nr":"","modus_supported":1,"params":"",
"check_sql":"select count(*) from qa_mask_field_sel F, qa_mask_execution E where E.tid=F.mask_execution_id and E.systeminfo_id=260"}
] />




--- Freemarker Magic
<#if sx_jobs_exists=1>
<#foreach job in jobs>
delete from sx_jobs where uniquename='${job.uniquename}';
</#foreach>
  <#if SQLdialect='Postgres'>
   select sp_update_sequence('sx_jobs');
  </#if>
<#foreach job in jobs>
insert into sx_jobs (uniquename,caption,filepath,sachgebiete_id,kenn_profil,hs_nr,modus_supported,params
<#if SQLdialect='Postgres'>,check_sql
</#if>)
values ('${job.uniquename}','${job.caption}','${job.filepath}',${job.sachgebiete_id},<#if job.kenn_profil!="">${job.kenn_profil}<#else>null::integer</#if>,
<#if job.hs_nr!="">${job.hs_nr}<#else>null::integer</#if>,${job.modus_supported},'${job.params}'
<#if SQLdialect='Postgres'>
,'${job.check_sql}'
</#if>
);
</#foreach>

<#if SQLdialect='Postgres'>
   select sp_update_sequence('sx_jobs');
  </#if>
  
  </#if>
