#!/bin/bash

OUTFILE=mask_execution_log.xml

echo "CMDLINE: $1 $2 $3 $4 $5"
cd $WEBAPP/WEB-INF

if [ "$LANG" = "de_DE.utf8" ]
then

ENCODING="UTF-8"

else

ENCODING="ISO-8859-1"

fi 

echo "<?xml version=\"1.0\"  encoding=\"$ENCODING\" ?>" >$OUTFILE
echo '<rs><row><fld name="execution_start">' >>$OUTFILE
date +'%d.%m.%Y %H:%M:%S' >>$OUTFILE
echo '</fld>' >>$OUTFILE

java -cp "$JDBC_CLASSPATH" $JAVA_OPTS de.superx.bin.ExecuteMask $1 $2 $3 $4 "$5" >tmp.log 2>&1

RESULT_CODE=$?

echo '<fld name="execution_end">' >>$OUTFILE
date +'%d.%m.%Y %H:%M:%S' >>$OUTFILE
echo '</fld>' >>$OUTFILE
echo '<fld name="result_log"><![CDATA[' >>$OUTFILE
cat tmp.log >>$OUTFILE
echo ']]></fld>' >>$OUTFILE
echo '<fld name="result_code">'$RESULT_CODE'</fld>' >>$OUTFILE
echo  '</row></rs>' >>$OUTFILE

